<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Terminy\Listeners\Udalost;

use App\Models\Pouzivatel\Pouzivatel;
use App\Models\Pracovisko\Pracovisko;
use Illuminate\Support\Facades\Notification;
use Seka\Portal\Modul\Terminy\Entities\Dtos\Factory\UdalostDTOFactory;
use Seka\Portal\Modul\Terminy\Events\Udalost\ZverejnenaUdalostBolaObnovena;
use Seka\Portal\Modul\Terminy\Notifications\Udalost\ZverejnenaNovaUdalostNotifikaciaDB;
use Seka\Portal\Modul\Terminy\Notifications\Udalost\ZverejnenaNovaUdalostNotifikaciaMail;

/**
 * Class ZverejnitObnovenuUdalostNotifikacia
 *
 * @package Seka\Portal\Modul\Terminy\Listeners\Udalost
 */
final class ZverejnitObnovenuUdalostNotifikacia
{
    /**
     * @param \Seka\Portal\Modul\Terminy\Events\Udalost\ZverejnenaUdalostBolaObnovena $event
     */
    public function handle(ZverejnenaUdalostBolaObnovena $event)
    {
        if ($event->udalost->nieJePovoleneUpozornenie()) {
            return;
        }

        $udalost = UdalostDTOFactory::make($event->udalost);

        Notification::send(
            Pouzivatel::query()->aktivny()->get(),
            new ZverejnenaNovaUdalostNotifikaciaDB($udalost)
        );

        Notification::send(
            Pracovisko::query()->get(),
            new ZverejnenaNovaUdalostNotifikaciaMail($udalost)
        );
    }
}
